/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#include "wx/wxprec.h"
//#ifdef __BORLANDC__
//#pragma hdrstop
//#endif
#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "injector.h"
#include "urlfunctions.h"
//#include "pro1.h"
#include <map>

extern MyFrame *mainWindow;

bool Injector::mInstanceFlag = false;
Injector* Injector::mSingle = NULL;
Injector* Injector::GetInstance()
{
	if(! mInstanceFlag)
	{
		mSingle = new Injector();
		mInstanceFlag = true;
		return mSingle;
	}
	else return mSingle;
}

void Injector::DoInjection(){
	wxTextCtrl* ctl = wxDynamicCast(mainWindow->FindWindow(RESPONSETXT), wxTextCtrl);
	ctl->SetValue(wxString::FromAscii(""));
	wxTextCtrl* host_ctl = wxDynamicCast(mainWindow->FindWindow(HOSTNAMETXTCTL ), wxTextCtrl);
	wxTextCtrl* port_ctl = wxDynamicCast(mainWindow->FindWindow(PORTTXTCTL), wxTextCtrl);
	wxTextCtrl* req_ctl = wxDynamicCast(mainWindow->FindWindow(INJREQUESTTXTCTL), wxTextCtrl);
	MyClientCollection *client_collection = MyClientCollection::GetInstance();
	MyClient* client = client_collection->GetClient();
	wxTextCtrl* inj_ctl = wxDynamicCast(mainWindow->FindWindow(INJSTRINGTXT), wxTextCtrl);
	wxString request = req_ctl->GetValue();
	size_t mark_pos = request.find(wxT("~~~"));
	if(mark_pos != wxString::npos){
		wxString second_part = request.Mid(mark_pos+3);
        request = request.Mid(0, mark_pos)+ UrlEncode(inj_ctl->GetValue()) + second_part;
	}
	client->SetRequestData(host_ctl->GetValue(),port_ctl->GetValue(),request, Injector::Callback, NULL);
	client->DoRequest();
}
void Injector::Callback(MyClient* client, void* WXUNUSED(clientData)){
	wxTextCtrl* ctl = wxDynamicCast(mainWindow->FindWindow(RESPONSETXT), wxTextCtrl);
	ctl->SetValue(client->mAnswer);
}
Injector::Injector(){
}
