/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#ifndef _MYCLIENT_H_
#define _MYCLIENT_H_
//#if defined(__GNUG__) && !defined(__APPLE__)
//#pragma interface "myclient.cpp"
//#endif
#include "wx/socket.h"
#include "wx/datetime.h"
#include "myframe.h"
#include "utils.h"
#include <list>
enum{
	ID_SOCKET2=550
};
class MyClient{
public:
	void OnSocketEvent(class wxSocketEvent& evt);
	void DoRequest();
	void OnInput();
	void OnClose();
	void OnOutput();
	~MyClient();
	void SetRequestData(wxString host, wxString port, wxString data, void (*callbackFunction)(MyClient* client , void* clientData), void *clientData);
	void (*mpCallbackFunction)(MyClient* client , void* clientData);
	void *mpClientData;
	wxSocketClient* mpSocket;
	wxString mAnswer;
	wxString mHost, mPort, mData;
private:
	//change the first header line to send to a proxy
	void ProxyData(wxString host, wxString port);

};
class MyClientCollection:public wxEvtHandler{
private:
    static bool mInstanceFlag;
    static MyClientCollection *mSingle;
	MyClientCollection();
public:
	void OnSocketEvent(class wxSocketEvent& evt);
	static MyClientCollection* GetInstance();
	MyClient* GetClient();
};

#endif
// _MYCLIENT_H_
