/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//#pragma hdrstop
//#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "myframe.h"
#include "inference.h"
#include "urlfunctions.h"
#include "options.h"
#include "wx/textfile.h"
#include "wx/txtstrm.h"
#include "wx/wfstream.h"
#include "wx/numdlg.h"
#include "wx/config.h"

////@begin XPM images
#include "open.xpm"
#include "save.xpm"
////@end XPM images
/*!
 * MyFrame type definition
 */

IMPLEMENT_CLASS( MyFrame, wxFrame )

/*!
 * MyFrame event table definition
 */

BEGIN_EVENT_TABLE( MyFrame, wxFrame )

////@begin MyFrame event table entries
    EVT_MENU( wxID_OPEN, MyFrame::OnOpenClick )

    EVT_MENU( ID_SAVE, MyFrame::OnSaveClick )

    EVT_MENU( wxID_SAVEAS, MyFrame::OnSaveasClick )

    EVT_MENU( wxID_PASTE, MyFrame::OnOptionsClick )

    EVT_MENU( wxID_ABOUT, MyFrame::OnAboutClick )

    EVT_BUTTON( FORWARDBTN, MyFrame::OnForwardbtnClick )

    EVT_BUTTON( SETINJECTIONBTN, MyFrame::OnSetinjectionbtnClick )

    EVT_CHECKBOX( INTERCEPTCHKBTN, MyFrame::OnInterceptchkbtnClick )

    EVT_CHECKBOX( FILTERNONHTMLCHKBTN, MyFrame::OnFilternonhtmlchkbtnClick )

    EVT_BUTTON( INJECTBTN, MyFrame::OnInjectbtnClick )

    EVT_BUTTON( INITIALIZEBTN, MyFrame::OnInitializebtnClick )

    EVT_CHOICE( PREDEFCHC, MyFrame::OnPredefchcSelected )

    EVT_BUTTON( INFERENCEBTN, MyFrame::OnInferencebtnClick )

    EVT_BUTTON( INFSTOPBTN, MyFrame::OnInfstopbtnClick )

////@end MyFrame event table entries

END_EVENT_TABLE()

MyFrame::~MyFrame(){
    //::wxLogDebug(_("Terminando"));
}

MyFrame::MyFrame( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Create( parent, id, caption, pos, size, style );
	MyServer *server = MyServer::GetInstance();
	wxCheckBox* intercept_ctl = wxDynamicCast(FindWindow(INTERCEPTCHKBTN), wxCheckBox);
	wxCheckBox* filter_ctl = wxDynamicCast(FindWindow(FILTERNONHTMLCHKBTN), wxCheckBox);
	server->SetOptions(intercept_ctl->IsChecked(), filter_ctl->IsChecked());
	wxSocketServer* pSock = server->CreateMyServerSocket(8888);
	if(pSock){
		server->MySetupSocketEvents(pSock,NULL,&OnNewRequest, &OnCloseRequest);
		wxConfig config(wxT("Injection Framework"), wxT("Flowgate"));
		config.Read(wxT("ProxyHost"), &Options::sProxyHost, wxString::FromAscii(""));
		config.Read(wxT("ProxyPort"), &Options::sProxyPort, wxString::FromAscii(""));
		config.Read(wxT("UseProxy"), &Options::sUseProxy, 0);
	} else{
		this->Destroy();
	}
}

/*!
 * MyFrame creator
 */

bool MyFrame::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin MyFrame member initialisation
////@end MyFrame member initialisation

////@begin MyFrame creation
    wxFrame::Create( parent, id, caption, pos, size, style );

    CreateControls();
    Centre();
////@end MyFrame creation
    return true;
}

/*!
 * Control creation for MyFrame
 */

void MyFrame::CreateControls()
{    
////@begin MyFrame content construction
    MyFrame* itemFrame1 = this;

    wxMenuBar* menuBar = new wxMenuBar;
    wxMenu* itemMenu3 = new wxMenu;
    {
        wxMenuItem* menuItem = new wxMenuItem(itemMenu3, wxID_OPEN, _("&Open...\tCtrl+O"), _("Opens a file"), wxITEM_NORMAL);
        wxBitmap bitmap(itemFrame1->GetBitmapResource(wxT("open.xpm")));
        menuItem->SetBitmap(bitmap);
        itemMenu3->Append(menuItem);
    }
    {
        wxMenuItem* menuItem = new wxMenuItem(itemMenu3, ID_SAVE, _("&Save\tCtrl+S"), _("Saves a file"), wxITEM_NORMAL);
        wxBitmap bitmap(itemFrame1->GetBitmapResource(wxT("save.xpm")));
        menuItem->SetBitmap(bitmap);
        itemMenu3->Append(menuItem);
    }
    itemMenu3->Append(wxID_SAVEAS, _("S&ave As..."), _("Saves a file to disk"), wxITEM_NORMAL);
    menuBar->Append(itemMenu3, _("&File"));
    wxMenu* itemMenu7 = new wxMenu;
    itemMenu7->Append(wxID_PASTE, _("&Options"), _("Pastes from the clipboard"), wxITEM_NORMAL);
    menuBar->Append(itemMenu7, _("&Configuration"));
    wxMenu* itemMenu9 = new wxMenu;
    itemMenu9->Append(wxID_ABOUT, _("&About..."), _("About this application"), wxITEM_NORMAL);
    menuBar->Append(itemMenu9, _("&Help"));
    itemFrame1->SetMenuBar(menuBar);

    wxSplitterWindow* itemSplitterWindow11 = new wxSplitterWindow( itemFrame1, ID_SPLITTERWINDOW, wxDefaultPosition, wxSize(100, 100), wxSP_3DBORDER|wxSP_3DSASH|wxNO_BORDER );

    wxNotebook* itemNotebook12 = new wxNotebook( itemSplitterWindow11, ID_NOTEBOOK1, wxDefaultPosition, wxDefaultSize, wxNB_TOP );

    wxPanel* itemPanel13 = new wxPanel( itemNotebook12, ID_PANEL4, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer14 = new wxBoxSizer(wxVERTICAL);
    itemPanel13->SetSizer(itemBoxSizer14);

    wxBoxSizer* itemBoxSizer15 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer14->Add(itemBoxSizer15, 0, wxALIGN_LEFT, 5);
    wxButton* itemButton16 = new wxButton( itemPanel13, FORWARDBTN, _("Forward"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer15->Add(itemButton16, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton17 = new wxButton( itemPanel13, SETINJECTIONBTN, _("Set as Injectable Request"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer15->Add(itemButton17, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxCheckBox* itemCheckBox18 = new wxCheckBox( itemPanel13, INTERCEPTCHKBTN, _("Intercept"), wxDefaultPosition, wxDefaultSize, wxCHK_2STATE );
    itemCheckBox18->SetValue(true);
    itemBoxSizer15->Add(itemCheckBox18, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxCheckBox* itemCheckBox19 = new wxCheckBox( itemPanel13, FILTERNONHTMLCHKBTN, _("Exclude non-html"), wxDefaultPosition, wxDefaultSize, wxCHK_2STATE );
    itemCheckBox19->SetValue(true);
    itemBoxSizer15->Add(itemCheckBox19, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxTextCtrl* itemTextCtrl20 = new wxTextCtrl( itemPanel13, PROXYTXTCTL, _T(""), wxDefaultPosition, wxSize(550, 150), wxTE_MULTILINE|wxTE_READONLY );
    itemBoxSizer14->Add(itemTextCtrl20, 1, wxGROW, 5);

    itemNotebook12->AddPage(itemPanel13, _("Proxy"));

    wxPanel* itemPanel21 = new wxPanel( itemNotebook12, ID_PANEL5, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer22 = new wxBoxSizer(wxVERTICAL);
    itemPanel21->SetSizer(itemBoxSizer22);

    wxBoxSizer* itemBoxSizer23 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer22->Add(itemBoxSizer23, 0, wxGROW|wxTOP, 5);
    wxStaticText* itemStaticText24 = new wxStaticText( itemPanel21, wxID_STATIC, _("Injection string"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer23->Add(itemStaticText24, 0, wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl25 = new wxTextCtrl( itemPanel21, INJSTRINGTXT, _T(""), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer23->Add(itemTextCtrl25, 1, wxALIGN_CENTER_VERTICAL, 5);

    wxBoxSizer* itemBoxSizer26 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer22->Add(itemBoxSizer26, 0, wxALIGN_LEFT|wxTOP, 5);
    wxButton* itemButton27 = new wxButton( itemPanel21, INJECTBTN, _("Go"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer26->Add(itemButton27, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxButton* itemButton28 = new wxButton( itemPanel21, ID_BUTTON15, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer26->Add(itemButton28, 0, wxALIGN_CENTER_VERTICAL|wxLEFT, 5);

    wxTextCtrl* itemTextCtrl29 = new wxTextCtrl( itemPanel21, RESPONSETXT, _T(""), wxDefaultPosition, wxSize(550, 150), wxTE_MULTILINE );
    itemBoxSizer22->Add(itemTextCtrl29, 1, wxGROW|wxTOP, 5);

    itemNotebook12->AddPage(itemPanel21, _("Injector"));

    wxPanel* itemPanel30 = new wxPanel( itemNotebook12, ID_PANEL7, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer31 = new wxBoxSizer(wxVERTICAL);
    itemPanel30->SetSizer(itemBoxSizer31);

    wxBoxSizer* itemBoxSizer32 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer31->Add(itemBoxSizer32, 0, wxGROW, 5);
    wxCheckBox* itemCheckBox33 = new wxCheckBox( itemPanel30, ADDQUOTESCHKBOX, _("Add quotes at extremes"), wxDefaultPosition, wxDefaultSize, wxCHK_2STATE );
    itemCheckBox33->SetValue(false);
    itemBoxSizer32->Add(itemCheckBox33, 0, wxALIGN_CENTER_VERTICAL|wxALL, 10);

    itemBoxSizer32->Add(5, 5, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton35 = new wxButton( itemPanel30, INITIALIZEBTN, _("Initialize injection"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer32->Add(itemButton35, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT, 15);

    wxStaticText* itemStaticText36 = new wxStaticText( itemPanel30, wxID_STATIC, _("Inference Engine Status: "), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer32->Add(itemStaticText36, 0, wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 5);

    wxStaticText* itemStaticText37 = new wxStaticText( itemPanel30, INFSTATELBL, _("Not initialized and waiting"), wxDefaultPosition, wxSize(150, -1), 0 );
    itemStaticText37->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Tahoma")));
    itemBoxSizer32->Add(itemStaticText37, 0, wxALIGN_CENTER_VERTICAL|wxLEFT, 15);

    wxStaticLine* itemStaticLine38 = new wxStaticLine( itemPanel30, wxID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
    itemBoxSizer31->Add(itemStaticLine38, 0, wxGROW, 5);

    wxBoxSizer* itemBoxSizer39 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer31->Add(itemBoxSizer39, 1, wxGROW, 5);
    wxBoxSizer* itemBoxSizer40 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer39->Add(itemBoxSizer40, 0, wxALIGN_TOP|wxALL, 5);
    wxFlexGridSizer* itemFlexGridSizer41 = new wxFlexGridSizer(2, 2, 5, 0);
    itemBoxSizer40->Add(itemFlexGridSizer41, 0, wxALIGN_LEFT, 5);
    wxStaticText* itemStaticText42 = new wxStaticText( itemPanel30, wxID_STATIC, _("DBMS"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer41->Add(itemStaticText42, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxString itemChoice43Strings[] = {
        _("MS SQL Server"),
        _("MySQL"),
        _("Oracle"),
        _("PostgresSql")
    };
    wxChoice* itemChoice43 = new wxChoice( itemPanel30, DATABASECHC, wxDefaultPosition, wxDefaultSize, 4, itemChoice43Strings, 0 );
    itemChoice43->SetStringSelection(_("MS SQL Server"));
    itemFlexGridSizer41->Add(itemChoice43, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);

    wxStaticText* itemStaticText44 = new wxStaticText( itemPanel30, wxID_STATIC, _("Simultaneous Connections"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer41->Add(itemStaticText44, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxString itemChoice45Strings[] = {
        _("1"),
        _("2"),
        _("3"),
        _("4"),
        _("5")
    };
    wxChoice* itemChoice45 = new wxChoice( itemPanel30, NUMCNTCHC, wxDefaultPosition, wxDefaultSize, 5, itemChoice45Strings, 0 );
    itemChoice45->SetStringSelection(_("3"));
    itemFlexGridSizer41->Add(itemChoice45, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);

    wxString itemRadioBox46Strings[] = {
        _("Inject Conjunction"),
        _("Inject Values")
    };
    wxRadioBox* itemRadioBox46 = new wxRadioBox( itemPanel30, INJTYPEBTN, _("Injection type"), wxDefaultPosition, wxDefaultSize, 2, itemRadioBox46Strings, 1, wxRA_SPECIFY_COLS|wxWANTS_CHARS );
    itemBoxSizer40->Add(itemRadioBox46, 0, wxALIGN_LEFT|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxStaticBox* itemStaticBoxSizer47Static = new wxStaticBox(itemPanel30, wxID_ANY, _("Inject Values"));
    wxStaticBoxSizer* itemStaticBoxSizer47 = new wxStaticBoxSizer(itemStaticBoxSizer47Static, wxVERTICAL);
    itemBoxSizer40->Add(itemStaticBoxSizer47, 1, wxGROW|wxRIGHT, 5);
    wxFlexGridSizer* itemFlexGridSizer48 = new wxFlexGridSizer(2, 2, 0, 0);
    itemStaticBoxSizer47->Add(itemFlexGridSizer48, 0, wxALIGN_CENTER_HORIZONTAL, 5);
    wxStaticText* itemStaticText49 = new wxStaticText( itemPanel30, wxID_STATIC, _("True value"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer48->Add(itemStaticText49, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl50 = new wxTextCtrl( itemPanel30, TRUEVALUETXT, _T(""), wxDefaultPosition, wxSize(250, -1), 0 );
    itemFlexGridSizer48->Add(itemTextCtrl50, 1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText51 = new wxStaticText( itemPanel30, wxID_STATIC, _("False value"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer48->Add(itemStaticText51, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl52 = new wxTextCtrl( itemPanel30, FALSEVALUETXT, _T(""), wxDefaultPosition, wxSize(250, -1), 0 );
    itemFlexGridSizer48->Add(itemTextCtrl52, 1, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticLine* itemStaticLine53 = new wxStaticLine( itemPanel30, wxID_STATIC, wxDefaultPosition, wxDefaultSize, wxLI_VERTICAL );
    itemBoxSizer39->Add(itemStaticLine53, 0, wxGROW, 5);

    wxBoxSizer* itemBoxSizer54 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer39->Add(itemBoxSizer54, 1, wxALIGN_TOP|wxALL, 5);
    wxString itemRadioBox55Strings[] = {
        _("Automatic"),
        _("By keyphrases")
    };
    wxRadioBox* itemRadioBox55 = new wxRadioBox( itemPanel30, INFTYPEBTN, _("Inference type"), wxDefaultPosition, wxDefaultSize, 2, itemRadioBox55Strings, 1, wxRA_SPECIFY_ROWS );
    itemBoxSizer54->Add(itemRadioBox55, 0, wxGROW|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    wxBoxSizer* itemBoxSizer56 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer54->Add(itemBoxSizer56, 1, wxGROW|wxALL, 5);
    wxStaticText* itemStaticText57 = new wxStaticText( itemPanel30, wxID_STATIC, _("True keyphrase"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer56->Add(itemStaticText57, 0, wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl58 = new wxTextCtrl( itemPanel30, TRUEKEYTXT, _T(""), wxDefaultPosition, wxSize(150, -1), 0 );
    itemBoxSizer56->Add(itemTextCtrl58, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    itemNotebook12->AddPage(itemPanel30, _("Inference Engine Options"));

    wxPanel* itemPanel59 = new wxPanel( itemNotebook12, ID_PANEL6, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer60 = new wxBoxSizer(wxVERTICAL);
    itemPanel59->SetSizer(itemBoxSizer60);

    wxFlexGridSizer* itemFlexGridSizer61 = new wxFlexGridSizer(2, 2, 0, 0);
    itemFlexGridSizer61->AddGrowableCol(1);
    itemBoxSizer60->Add(itemFlexGridSizer61, 0, wxGROW|wxLEFT|wxTOP|wxBOTTOM, 4);
    wxStaticText* itemStaticText62 = new wxStaticText( itemPanel59, wxID_STATIC, _("Predefined Queries"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer61->Add(itemStaticText62, 0, wxALIGN_LEFT|wxALIGN_TOP|wxALL|wxADJUST_MINSIZE, 5);

    wxBoxSizer* itemBoxSizer63 = new wxBoxSizer(wxHORIZONTAL);
    itemFlexGridSizer61->Add(itemBoxSizer63, 1, wxGROW|wxALIGN_CENTER_VERTICAL, 5);
    wxString itemChoice64Strings[] = {
        _("SQL Server - Get username"),
        _("SQL Server - Get table names"),
        _("SQL Server - Get column names"),
        _("MySQL 5 - Get table names"),
        _("MySQL 5 - Get column names"),
        _("PostgreSQL - Get table names"),
        _("PostgreSQL - Get column names"),
        _("Oracle - Get table names"),
        _("Oracle - Get column names")
    };
    wxChoice* itemChoice64 = new wxChoice( itemPanel59, PREDEFCHC, wxDefaultPosition, wxDefaultSize, 9, itemChoice64Strings, 0 );
    itemBoxSizer63->Add(itemChoice64, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxBOTTOM, 5);

    itemBoxSizer63->Add(5, 5, 1, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticText* itemStaticText66 = new wxStaticText( itemPanel59, wxID_STATIC, _("Inference Engine Status: "), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer63->Add(itemStaticText66, 0, wxALIGN_CENTER_VERTICAL, 5);

    wxStaticText* itemStaticText67 = new wxStaticText( itemPanel59, INFSTATE2LBL, _("Not initialized and waiting"), wxDefaultPosition, wxSize(150, -1), 0 );
    itemStaticText67->SetFont(wxFont(8, wxSWISS, wxNORMAL, wxBOLD, false, _T("Tahoma")));
    itemBoxSizer63->Add(itemStaticText67, 0, wxALIGN_CENTER_VERTICAL|wxLEFT, 15);

    wxStaticText* itemStaticText68 = new wxStaticText( itemPanel59, wxID_STATIC, _("Query"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer61->Add(itemStaticText68, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl69 = new wxTextCtrl( itemPanel59, QUERYTXT, _T(""), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer61->Add(itemTextCtrl69, 1, wxGROW|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5);

    wxBoxSizer* itemBoxSizer70 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer60->Add(itemBoxSizer70, 0, wxGROW, 5);
    wxButton* itemButton71 = new wxButton( itemPanel59, INFERENCEBTN, _("Start"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer70->Add(itemButton71, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 10);

    wxButton* itemButton72 = new wxButton( itemPanel59, INFSTOPBTN, _("Stop"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer70->Add(itemButton72, 0, wxALIGN_CENTER_VERTICAL|wxRIGHT, 20);

    wxString itemRadioBox73Strings[] = {
        _("Single"),
        _("List")
    };
    wxRadioBox* itemRadioBox73 = new wxRadioBox( itemPanel59, RESULTBTN, _("Result Type"), wxDefaultPosition, wxDefaultSize, 2, itemRadioBox73Strings, 1, wxRA_SPECIFY_COLS );
    itemBoxSizer70->Add(itemRadioBox73, 0, wxALIGN_BOTTOM|wxLEFT, 5);

    wxBoxSizer* itemBoxSizer74 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer70->Add(itemBoxSizer74, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);
    wxBoxSizer* itemBoxSizer75 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer74->Add(itemBoxSizer75, 0, wxGROW|wxTOP, 5);
    wxStaticText* itemStaticText76 = new wxStaticText( itemPanel59, wxID_STATIC, _("Index"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer75->Add(itemStaticText76, 0, wxALIGN_TOP|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl77 = new wxTextCtrl( itemPanel59, KEYNAMETXT, _T(""), wxDefaultPosition, wxSize(150, -1), 0 );
    itemBoxSizer75->Add(itemTextCtrl77, 1, wxALIGN_CENTER_VERTICAL|wxRIGHT, 5);

    wxTextCtrl* itemTextCtrl78 = new wxTextCtrl( itemPanel59, ENGINEOUTPUT, _T(""), wxDefaultPosition, wxSize(550, 150), wxTE_MULTILINE );
    itemBoxSizer60->Add(itemTextCtrl78, 1, wxGROW|wxTOP, 5);

    itemNotebook12->AddPage(itemPanel59, _("Inference Engine"));

    wxPanel* itemPanel79 = new wxPanel( itemNotebook12, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer80 = new wxBoxSizer(wxVERTICAL);
    itemPanel79->SetSizer(itemBoxSizer80);

    wxStaticText* itemStaticText81 = new wxStaticText( itemPanel79, wxID_STATIC, _("Last Request"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer80->Add(itemStaticText81, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl82 = new wxTextCtrl( itemPanel79, LASTREQUESTTXTCTL, _T(""), wxDefaultPosition, wxSize(550, 120), wxTE_MULTILINE );
    itemBoxSizer80->Add(itemTextCtrl82, 1, wxGROW, 5);

    wxStaticText* itemStaticText83 = new wxStaticText( itemPanel79, wxID_STATIC, _("Last Response"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer80->Add(itemStaticText83, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl84 = new wxTextCtrl( itemPanel79, LASTRESPONSETXTCTL, _T(""), wxDefaultPosition, wxSize(550, -1), wxTE_MULTILINE );
    itemBoxSizer80->Add(itemTextCtrl84, 1, wxGROW, 5);

    itemNotebook12->AddPage(itemPanel79, _("Network Spy"));

    wxPanel* itemPanel85 = new wxPanel( itemSplitterWindow11, ID_PANEL, wxDefaultPosition, wxDefaultSize, wxSUNKEN_BORDER|wxTAB_TRAVERSAL );
    wxBoxSizer* itemBoxSizer86 = new wxBoxSizer(wxHORIZONTAL);
    itemPanel85->SetSizer(itemBoxSizer86);

    wxBoxSizer* itemBoxSizer87 = new wxBoxSizer(wxVERTICAL);
    itemBoxSizer86->Add(itemBoxSizer87, 0, wxALIGN_TOP, 5);
    wxStaticBox* itemStaticBoxSizer88Static = new wxStaticBox(itemPanel85, wxID_ANY, _("Target Host"));
    wxStaticBoxSizer* itemStaticBoxSizer88 = new wxStaticBoxSizer(itemStaticBoxSizer88Static, wxHORIZONTAL);
    itemBoxSizer87->Add(itemStaticBoxSizer88, 0, wxALIGN_LEFT|wxALL, 5);
    wxTextCtrl* itemTextCtrl89 = new wxTextCtrl( itemPanel85, HOSTNAMETXTCTL, _T(""), wxDefaultPosition, wxSize(150, -1), 0 );
    itemStaticBoxSizer88->Add(itemTextCtrl89, 1, wxALIGN_CENTER_VERTICAL, 5);

    wxStaticBox* itemStaticBoxSizer90Static = new wxStaticBox(itemPanel85, wxID_ANY, _("Target Port"));
    wxStaticBoxSizer* itemStaticBoxSizer90 = new wxStaticBoxSizer(itemStaticBoxSizer90Static, wxHORIZONTAL);
    itemBoxSizer87->Add(itemStaticBoxSizer90, 0, wxALIGN_LEFT|wxALL, 5);
    wxTextCtrl* itemTextCtrl91 = new wxTextCtrl( itemPanel85, PORTTXTCTL, _T(""), wxDefaultPosition, wxSize(80, -1), 0 );
    itemStaticBoxSizer90->Add(itemTextCtrl91, 0, wxALIGN_CENTER_VERTICAL, 5);

    wxStaticText* itemStaticText92 = new wxStaticText( itemPanel85, wxID_STATIC, _("Write \"~~~\" on the Injectable\nRequest to setup the injection \npoint."), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer87->Add(itemStaticText92, 0, wxALIGN_LEFT|wxALL|wxADJUST_MINSIZE, 5);

    wxStaticBox* itemStaticBoxSizer93Static = new wxStaticBox(itemPanel85, wxID_ANY, _("Injectable Request"));
    wxStaticBoxSizer* itemStaticBoxSizer93 = new wxStaticBoxSizer(itemStaticBoxSizer93Static, wxHORIZONTAL);
    itemBoxSizer86->Add(itemStaticBoxSizer93, 1, wxGROW|wxALL, 5);
    wxTextCtrl* itemTextCtrl94 = new wxTextCtrl( itemPanel85, INJREQUESTTXTCTL, _T(""), wxDefaultPosition, wxSize(-1, 100), wxTE_MULTILINE );
    itemStaticBoxSizer93->Add(itemTextCtrl94, 1, wxGROW, 0);

    itemSplitterWindow11->SplitHorizontally(itemNotebook12, itemPanel85, 320);

////@end MyFrame content construction
}
/*!
 * Should we show tooltips?
 */
bool MyFrame::ShowToolTips()
{
    return true;
}
/*!
 * Get bitmap resources
 */
wxBitmap MyFrame::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin MyFrame bitmap retrieval
    wxUnusedVar(name);
    if (name == _T("open.xpm"))
    {
        wxBitmap bitmap(open_xpm);
        return bitmap;
    }
    else if (name == _T("save.xpm"))
    {
        wxBitmap bitmap(save_xpm);
        return bitmap;
    }
    return wxNullBitmap;
////@end MyFrame bitmap retrieval
}
/*!
 * Get icon resources
 */
wxIcon MyFrame::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin MyFrame icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end MyFrame icon retrieval
}
void MyFrame::OnForwardbtnClick( wxCommandEvent& WXUNUSED(event) )
{
	MyServer *server = MyServer::GetInstance();
	server->SendNextRequest();
}
void MyFrame::OnSetinjectionbtnClick( wxCommandEvent& WXUNUSED(event) )
{
	MyServer *server = MyServer::GetInstance();
	ObjHttpRequest* req = server->GetCurrentRequest();
	wxTextCtrl* host_ctl = wxDynamicCast(FindWindow(HOSTNAMETXTCTL ), wxTextCtrl);
	wxTextCtrl* port_ctl = wxDynamicCast(FindWindow(PORTTXTCTL), wxTextCtrl);
	wxTextCtrl* req_ctl = wxDynamicCast(FindWindow(INJREQUESTTXTCTL), wxTextCtrl);
	if(req){
		host_ctl->SetValue(req->mProxyHostname);
		port_ctl->SetValue(req->mProxyService);
		req_ctl->SetValue(req->mData);
	} else {
		host_ctl->SetValue(wxString::FromAscii(""));
		port_ctl->SetValue(wxString::FromAscii(""));
		req_ctl->SetValue(wxString::FromAscii(""));
	}
}
/*void MyFrame::OnDump( wxCommandEvent& WXUNUSED(event) )
{
	Context *ctx = Context::GetInstance();
	ctx->Dump();
	ctx->CheckPoint();
	MyServer *server = MyServer::GetInstance();
	server->Dump();
}
void MyFrame::OnDumpAll( wxCommandEvent& WXUNUSED(event) )
{
	Context *ctx = Context::GetInstance();
	ctx->DumpAll();
	MyServer *server = MyServer::GetInstance();
	server->Dump();
}*/
void OnNewRequest(wxString request){

}
void OnCloseRequest(){

}
void MyFrame::OnInterceptchkbtnClick( wxCommandEvent& event )
{
	MyServer *server = MyServer::GetInstance();
	server->mIntercept = event.IsChecked();	
	event.Skip();
}
void MyFrame::OnFilternonhtmlchkbtnClick( wxCommandEvent& event )
{
	MyServer *server = MyServer::GetInstance();
	server->mExcludeNonhtml = event.IsChecked();
	event.Skip();
}
void MyFrame::OnInjectbtnClick( wxCommandEvent& WXUNUSED(event) )
{
	Injector* injector = Injector::GetInstance();
	injector->DoInjection();
}
void MyFrame::UpdateEngineState(wxString msg){
	InferenceEngine* engine = InferenceEngine::GetInstance();
	wxString state = engine->GetStateMsg();
	wxDynamicCast(FindWindow(INFSTATE2LBL), wxStaticText)->SetLabel(state);
	wxDynamicCast(FindWindow(INFSTATELBL), wxStaticText)->SetLabel(state);
	if(msg.length()) wxLogWarning(msg);
}
void MyFrame::LoadInferenceOptions(){
	wxChoice* database_chc = wxDynamicCast(FindWindow(DATABASECHC), wxChoice);
	wxRadioBox* injtype_btn = wxDynamicCast(FindWindow(INJTYPEBTN), wxRadioBox);
	wxChoice* numcnt_chc = wxDynamicCast(FindWindow(NUMCNTCHC), wxChoice);
	wxRadioBox* inftype_btn = wxDynamicCast(FindWindow(INFTYPEBTN), wxRadioBox);
	wxRadioBox* result_btn = wxDynamicCast(FindWindow(RESULTBTN), wxRadioBox);
	wxTextCtrl* truevalue_txt = wxDynamicCast(FindWindow(TRUEVALUETXT), wxTextCtrl);
	wxTextCtrl* falsevalue_txt = wxDynamicCast(FindWindow(FALSEVALUETXT), wxTextCtrl);
	wxTextCtrl* truekey_txt = wxDynamicCast(FindWindow(TRUEKEYTXT), wxTextCtrl);
	//wxTextCtrl* falsekey_txt = wxDynamicCast(FindWindow(FALSEKEYTXT), wxTextCtrl);
	wxTextCtrl* hostname_txtctl = wxDynamicCast(FindWindow(HOSTNAMETXTCTL), wxTextCtrl);
	wxTextCtrl* port_txtctl = wxDynamicCast(FindWindow(PORTTXTCTL), wxTextCtrl);
	wxTextCtrl* injrequest_txtctl = wxDynamicCast(FindWindow(INJREQUESTTXTCTL), wxTextCtrl);
	wxTextCtrl* query_txt = wxDynamicCast(FindWindow(QUERYTXT), wxTextCtrl);
	wxTextCtrl* keyname_txt = wxDynamicCast(FindWindow(KEYNAMETXT), wxTextCtrl);
	wxTextCtrl* output_txt = wxDynamicCast(FindWindow(ENGINEOUTPUT), wxTextCtrl);
	wxCheckBox* addquotes_chkbox = wxDynamicCast(FindWindow(ADDQUOTESCHKBOX), wxCheckBox);
	InferenceEngine* engine = InferenceEngine::GetInstance();
	InferenceEngine::DatabaseType database = InferenceEngine::ENG_MSSQL;
	switch(database_chc->GetSelection()){
		case 0:
		database = InferenceEngine::ENG_MSSQL;
		break;
		case 1:
		database = InferenceEngine::ENG_MYSQL;
		break;
		case 2:
		database = InferenceEngine::ENG_ORACLE;
		break;
		case 3:
		database = InferenceEngine::ENG_PSSQL;
		break;
	}
	engine->SetOptions((inftype_btn->GetSelection() == 1)?InferenceEngine::ENG_BYKEY : InferenceEngine::ENG_AUTO,  (result_btn->GetSelection() == 0)?InferenceEngine::ENG_SINGLE : InferenceEngine::ENG_LIST, (injtype_btn->GetSelection() == 0) ? InferenceEngine::ENG_CONJ : InferenceEngine::ENG_VALUES, truevalue_txt->GetValue(), falsevalue_txt->GetValue(),  truekey_txt->GetValue(),  wxT("")/*falsekey_txt->GetValue()*/,  query_txt->GetValue(), keyname_txt->GetValue(),  output_txt,  hostname_txtctl->GetValue(),  port_txtctl->GetValue(), injrequest_txtctl->GetValue(), database, numcnt_chc->GetSelection()+1, this, addquotes_chkbox->IsChecked());
}
void MyFrame::OnInferencebtnClick( wxCommandEvent& WXUNUSED(event) )
{
	InferenceEngine* engine = InferenceEngine::GetInstance();
	engine->Stop();
	LoadInferenceOptions();
	wxString error = engine->StartInjections();
	if(error.length()){
		wxLogWarning(error);
	}
	UpdateEngineState(wxT(""));
}
void MyFrame::OnInfstopbtnClick( wxCommandEvent& WXUNUSED(event) )
{
	InferenceEngine* engine = InferenceEngine::GetInstance();
	engine->Stop();
	UpdateEngineState(wxT(""));
}
void MyFrame::Save(wxString path){
	wxTextFile file;
	if(file.Create(path) || file.Open(path)){
		mPath = path;
		file.Clear();
		int database = wxDynamicCast(FindWindow(DATABASECHC), wxChoice)->GetSelection();
		int numcnt   = wxDynamicCast(FindWindow(NUMCNTCHC), wxChoice)->GetSelection();
		int injtype  = wxDynamicCast(FindWindow(INJTYPEBTN), wxRadioBox)->GetSelection();
		int inftype  = wxDynamicCast(FindWindow(INFTYPEBTN), wxRadioBox)->GetSelection();
		int resulttype = wxDynamicCast(FindWindow(RESULTBTN), wxRadioBox)->GetSelection();
		wxString truevalue = wxDynamicCast(FindWindow(TRUEVALUETXT), wxTextCtrl)->GetValue();
		wxString falsevalue = wxDynamicCast(FindWindow(FALSEVALUETXT), wxTextCtrl)->GetValue();
		wxString truekey = wxDynamicCast(FindWindow(TRUEKEYTXT), wxTextCtrl)->GetValue();
//		wxString falsekey = wxDynamicCast(FindWindow(FALSEKEYTXT), wxTextCtrl)->GetValue();
		wxString hostname = wxDynamicCast(FindWindow(HOSTNAMETXTCTL), wxTextCtrl)->GetValue();
		bool addquotes = wxDynamicCast(FindWindow(ADDQUOTESCHKBOX), wxCheckBox)->IsChecked();
		wxString port = wxDynamicCast(FindWindow(PORTTXTCTL), wxTextCtrl)->GetValue();
		wxString injrequest = wxDynamicCast(FindWindow(INJREQUESTTXTCTL), wxTextCtrl)->GetValue();
		wxString query = wxDynamicCast(FindWindow(QUERYTXT), wxTextCtrl)->GetValue();
		wxString keyname = wxDynamicCast(FindWindow(KEYNAMETXT), wxTextCtrl)->GetValue();

		file.AddLine(wxT("database ")+ wxString::Format(wxT("%d"), database));
		file.AddLine(wxT("numcnt ")+ wxString::Format(wxT("%d"), numcnt+1));
		file.AddLine(wxT("injtype ") + wxString::Format(wxT("%d"), injtype));
		file.AddLine(wxT("inftype ") + wxString::Format(wxT("%d"), inftype));
		file.AddLine(wxT("resulttype ") + wxString::Format(wxT("%d"), resulttype));
		if(!truevalue.length())truevalue = wxT(" ");
		file.AddLine(wxT("truevalue ") + UrlEncode(truevalue));
		if(!falsevalue.length())falsevalue = wxT(" ");
		file.AddLine(wxT("falsevalue ") + UrlEncode(falsevalue));
		if(!truekey.length())truekey = wxT(" ");
		file.AddLine(wxT("truekey ") + UrlEncode(truekey));
//		if(!falsekey.length())falsekey = wxT(" ");
//		file.AddLine(wxT("falsekey ") + UrlEncode(falsekey));
		if(!hostname.length())hostname = wxT(" ");
		file.AddLine(wxT("hostname ") + UrlEncode(hostname));
		file.AddLine((wxString) wxT("addquotes ") + (addquotes?wxT("true"):wxT("false")));
		if(!query.length())query = wxT(" ");
		file.AddLine(wxT("query ") + UrlEncode(query));
		if(!keyname.length())keyname = wxT(" ");
		file.AddLine(wxT("keyname ") + UrlEncode(keyname));
		if(!port.length())port = wxT(" ");
		file.AddLine(wxT("port ") + UrlEncode(port));
		if(!injrequest.length())injrequest = wxT(" ");
		file.AddLine(wxT("injrequest ") + UrlEncode(injrequest));
		file.Write();
	}
}
void MyFrame::OnSaveasClick( wxCommandEvent& WXUNUSED(event) )
{
	wxString caption = wxT("Choose a file");
	wxString wildcard =	wxT("INJ files |*.inj");
	wxString defaultDir = wxT("");
	wxString defaultFilename = wxEmptyString;

	wxFileDialog dialog(this, caption, defaultDir, defaultFilename, wildcard, wxSAVE);
	if (dialog.ShowModal() == wxID_OK)
	{
		wxString path = dialog.GetPath();
		if(wxFile::Exists(path)){
			//#include "wx/msgdlg.h"
			wxMessageDialog dialog( NULL, wxT("The file already exsists. Do you want to overwrite?"),
			wxT("File already exsists"), wxYES_NO);
			if(dialog.ShowModal() == wxID_YES) Save(path);
		} else Save(path);
	}
}
void MyFrame::OnSaveClick( wxCommandEvent& WXUNUSED(event) )
{
	if(mPath.length()) Save(mPath);
	else{
		wxString caption = wxT("Choose a file");
		wxString wildcard =	wxT("INJ files |*.inj");
		wxString defaultDir = wxT("");
		wxString defaultFilename = wxEmptyString;
		wxFileDialog dialog(this, caption, defaultDir, defaultFilename, wildcard, wxSAVE);
		if (dialog.ShowModal() == wxID_OK)
		{
			wxString path = dialog.GetPath();
			Save(path);
		}
	}
}
void MyFrame::OnOpenClick( wxCommandEvent& WXUNUSED(event))
{
	wxString caption = wxT("Choose a file");
	wxString wildcard =	wxT("INJ files |*.inj");
	wxString defaultDir = wxT("");
	wxString defaultFilename = wxEmptyString;

	wxFileDialog dialog(this, caption, defaultDir, defaultFilename, wildcard, wxOPEN);
	if (dialog.ShowModal() == wxID_OK)
	{
		wxString path = dialog.GetPath();
		wxFileInputStream file(path);
		wxTextInputStream text(file);
		while(file.IsOk() && !file.Eof()){
			mPath = path;
			wxString key;
			int i_value;
			wxString s_value;
			text>>key;
			if(key == wxT("database")){
				text>>i_value;
				wxDynamicCast(FindWindow(DATABASECHC), wxChoice)->SetSelection(i_value);
			} else if(key == wxT("inftype")){
				text>>i_value;
				wxDynamicCast(FindWindow(INFTYPEBTN), wxRadioBox)->SetSelection(i_value);
			} else if(key == wxT("resulttype")){
				text>>i_value;
				wxDynamicCast(FindWindow(RESULTBTN), wxRadioBox)->SetSelection(i_value);
			} else if(key == wxT("numcnt")){
				text>>i_value;
				wxDynamicCast(FindWindow(NUMCNTCHC), wxChoice)->SetSelection(i_value - 1);
			} else if(key == wxT("injtype")){
				text>>i_value;
				wxDynamicCast(FindWindow(INJTYPEBTN), wxRadioBox)->SetSelection(i_value);
			} else if(key == wxT("database")){
				text>>i_value;
				wxDynamicCast(FindWindow(DATABASECHC), wxRadioBox)->SetSelection(i_value);
			} else if(key == wxT("falsevalue")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(FALSEVALUETXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("truevalue")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(TRUEVALUETXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("truekey")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(TRUEKEYTXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("port")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(PORTTXTCTL), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("hostname")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(HOSTNAMETXTCTL), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("addquotes")){
				text>>s_value;
				wxDynamicCast(FindWindow(ADDQUOTESCHKBOX), wxCheckBox)->SetValue(s_value == wxT("true"));
			} else if(key == wxT("falsekey")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
//				wxDynamicCast(FindWindow(FALSEKEYTXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("keyname")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(KEYNAMETXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("query")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(QUERYTXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("injrequest")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(INJREQUESTTXTCTL), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("keyname")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(KEYNAMETXT), wxTextCtrl)->SetValue(s_value);
			} else if(key == wxT("query")){
				text>>s_value;
				s_value = UrlDecode(s_value);
				if(s_value == wxT(" ")) s_value = wxT("");
				wxDynamicCast(FindWindow(QUERYTXT), wxTextCtrl)->SetValue(s_value);
			}
		}
	}
}/*!
 * wxEVT_COMMAND_CHOICE_SELECTED event handler for ID_CHOICE
 */

void MyFrame::OnPredefchcSelected( wxCommandEvent& event )
{
	wxString query, keyname;
	int result;
	if(event.GetString() == wxT("SQL Server - Get username")){
		query = wxT("select user");
		result = 0;
	} else if(event.GetString() == wxT("SQL Server - Get column names")){
		query = wxT("select column_name from information_schema.columns where table_name = '[REPLACE BY TABLE NAME]' ");
		result = 1;
		keyname = wxT("column_name");
	} else if(event.GetString() == wxT("SQL Server - Get table names")){
		query = wxT("select table_name from information_schema.tables where table_type <> 'view'");
		keyname = wxT("table_name");
		result = 1;
	} else if(event.GetString() == wxT("MySQL 5 - Get table names")){
		query = wxT("select table_schema, table_name from information_schema.tables where table_schema<>'information_schema' and table_schema<>'mysql'");
		keyname = wxT("table_name");
		result = 1;
	} else if(event.GetString() == wxT("MySQL 5 - Get column names")){
		query = wxT("select column_name,data_type from information_schema.columns where table_name = '[REPLACE BY TABLE NAME]'");
		keyname = wxT("column_name");
		result = 1;
	} else if(event.GetString() == wxT("Get table names")){
		query = wxT("select table_schema, table_name from information_schema.tables where table_schema<>'information_schema' and table_schema<>'mysql'");
		keyname = wxT("table_name");
		result = 1;
	} else if(event.GetString() == wxT("PostgreSQL - Get table names")){
		query = wxT("SELECT oid,relname FROM pg_class where substr(relname,1,3)<>'pg_' and substr(relname,1,4)<>'sql_' and relkind='r'");
		keyname = wxT("relname");
		result = 1;
	} else if(event.GetString() == wxT("PostgreSQL - Get column names")){
		query = wxT("select attname from pg_attribute where attrelid=[REPLACE BY TABLE OID] and attnum>0");
		keyname = wxT("attname");
		result = 1;
	} else if(event.GetString() == wxT("Oracle - Get table names")){
		query = wxT("select table_name from user_tables");
		keyname = wxT("table_name");
		result = 1;
	} else if(event.GetString() == wxT("Oracle - Get column names")){
		query = wxT("select COLUMN_NAME,DATA_TYPE from ALL_TAB_COLS where TABLE_NAME='[REPLACE BY TABLE NAME]'");
		keyname = wxT("COLUMN_NAME");
		result = 1;
	} else return;
	wxDynamicCast(FindWindow(QUERYTXT), wxTextCtrl)->SetValue(query);
	wxDynamicCast(FindWindow(RESULTBTN), wxRadioBox)->SetSelection(result);
	wxDynamicCast(FindWindow(KEYNAMETXT), wxTextCtrl)->SetValue(keyname);
}
/*!
 * wxEVT_COMMAND_MENU_SELECTED event handler for wxID_ABOUT
 */

void MyFrame::OnAboutClick( wxCommandEvent& WXUNUSED(event) )
{
	AboutDialog dialog(this);
	dialog.ShowModal();
}
void MyFrame::OnOptionsClick( wxCommandEvent& WXUNUSED(event) )
{
	wxConfig config(wxT("Injection Framework"), wxT("Flowgate"));

	OptionsDialog dialog(this);
	dialog.SetUseProxy(Options::sUseProxy);
	dialog.SetProxyPort(Options::sProxyPort);
	dialog.SetProxyHost(Options::sProxyHost);
	if(dialog.ShowModal() == wxID_OK){
		Options::sProxyHost = dialog.GetProxyHost();
		Options::sProxyPort = dialog.GetProxyPort();
		Options::sUseProxy = dialog.GetUseProxy();
		config.Write(wxT("ProxyHost"), Options::sProxyHost);
		config.Write(wxT("ProxyPort"), Options::sProxyPort);
		config.Write(wxT("UseProxy"), Options::sUseProxy);
	}
}
void MyFrame::OnInitializebtnClick( wxCommandEvent& WXUNUSED(event) )
{
	InferenceEngine* engine = InferenceEngine::GetInstance();
	engine->Stop();
	LoadInferenceOptions();
	wxString error= engine->Initialize();
	if(error.length()){
		wxLogWarning(error);
	}
	UpdateEngineState(wxT(""));	
}
