/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#ifndef _MYFRAME_H_
#define _MYFRAME_H_

//#if defined(__GNUG__) && !defined(__APPLE__)
//#pragma interface "myframe.cpp"
//#endif

/*!
 * Includes
 */

////@begin includes
#include "wx/frame.h"
#include "wx/splitter.h"
#include "wx/notebook.h"
#include "wx/statline.h"
////@end includes
#include "mysock.h"
#include "myserver.h"
#include "myclient.h"
#include "injector.h"
#include "optionsdialog.h"
#include "aboutdialog.h"
#include "view.h"
/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_FRAME 10000
#define SYMBOL_MYFRAME_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxMINIMIZE_BOX|wxMAXIMIZE_BOX|wxCLOSE_BOX
#define SYMBOL_MYFRAME_TITLE _("Injection Framework")
#define SYMBOL_MYFRAME_IDNAME ID_FRAME
#define SYMBOL_MYFRAME_SIZE wxSize(700, 550)
#define SYMBOL_MYFRAME_POSITION wxDefaultPosition
#define ID_SAVE 10041
#define ID_SPLITTERWINDOW 10012
#define ID_NOTEBOOK1 10002
#define ID_PANEL4 10003
#define FORWARDBTN 10016
#define SETINJECTIONBTN 10017
#define INTERCEPTCHKBTN 10018
#define FILTERNONHTMLCHKBTN 10027
#define PROXYTXTCTL 10036
#define ID_PANEL5 10013
#define INJSTRINGTXT 10029
#define INJECTBTN 10030
#define ID_BUTTON15 10032
#define RESPONSETXT 10010
#define ID_PANEL7 10015
#define ADDQUOTESCHKBOX 10022
#define INITIALIZEBTN 10023
#define INFSTATELBL 10024
#define DATABASECHC 10039
#define NUMCNTCHC 10042
#define INJTYPEBTN 10034
#define TRUEVALUETXT 10033
#define FALSEVALUETXT 10035
#define INFTYPEBTN 10021
#define TRUEKEYTXT 10025
#define ID_PANEL6 10014
#define PREDEFCHC 10050
#define INFSTATE2LBL 10051
#define QUERYTXT 10005
#define INFERENCEBTN 10008
#define INFSTOPBTN 10009
#define RESULTBTN 10053
#define KEYNAMETXT 10049
#define ENGINEOUTPUT 10020
#define ID_PANEL3 10019
#define LASTREQUESTTXTCTL 10028
#define LASTRESPONSETXTCTL 10031
#define ID_PANEL 10004
#define HOSTNAMETXTCTL 10006
#define PORTTXTCTL 10038
#define INJREQUESTTXTCTL 10007
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif

/*!
 * MyFrame class declaration
 */

class MyFrame: public wxFrame, EngineView
{    
    DECLARE_CLASS( MyFrame )
    DECLARE_EVENT_TABLE()


public:
    /// Constructors
    MyFrame( );
    ~MyFrame( );
    MyFrame( wxWindow* parent, wxWindowID id = SYMBOL_MYFRAME_IDNAME, const wxString& caption = SYMBOL_MYFRAME_TITLE, const wxPoint& pos = SYMBOL_MYFRAME_POSITION, const wxSize& size = SYMBOL_MYFRAME_SIZE, long style = SYMBOL_MYFRAME_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_MYFRAME_IDNAME, const wxString& caption = SYMBOL_MYFRAME_TITLE, const wxPoint& pos = SYMBOL_MYFRAME_POSITION, const wxSize& size = SYMBOL_MYFRAME_SIZE, long style = SYMBOL_MYFRAME_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin MyFrame event handler declarations

    /// wxEVT_COMMAND_MENU_SELECTED event handler for wxID_OPEN
    void OnOpenClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_SAVE
    void OnSaveClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for wxID_SAVEAS
    void OnSaveasClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for wxID_PASTE
    void OnOptionsClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for wxID_ABOUT
    void OnAboutClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for FORWARDBTN
    void OnForwardbtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for SETINJECTIONBTN
    void OnSetinjectionbtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for INTERCEPTCHKBTN
    void OnInterceptchkbtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for FILTERNONHTMLCHKBTN
    void OnFilternonhtmlchkbtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for INJECTBTN
    void OnInjectbtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for INITIALIZEBTN
    void OnInitializebtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHOICE_SELECTED event handler for PREDEFCHC
    void OnPredefchcSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for INFERENCEBTN
    void OnInferencebtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for INFSTOPBTN
    void OnInfstopbtnClick( wxCommandEvent& event );

////@end MyFrame event handler declarations

////@begin MyFrame member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end MyFrame member function declarations
   /// Should we show tooltips?
    static bool ShowToolTips();

	void Save(wxString path);
	wxString mPath;

	////@begin MyFrame member variables
////@end MyFrame member variables
	void UpdateEngineState(wxString msg);
private:
	void LoadInferenceOptions();
};
void OnNewRequest(wxString request);
void OnCloseRequest();

#endif
    // _MYFRAME_H_
