/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#ifndef _MYSERVER_H_
#define _MYSERVER_H_
//#if defined(__GNUG__) && !defined(__APPLE__)
//#pragma interface "myserver.cpp"
//#endif
#include "wx/socket.h"
#include "wx/datetime.h"
#include "myframe.h"
#include "utils.h"
#include "states.h"
#include "types.h"
#include <list>
#include "mysock.h"
enum{
	SOCKET_ID=500,
	ID_SERVER,
	ID_SOCKET
};
#define SOCKET_TIMEOUT  10
class MyServer;
class ObjHttpRequest;
class ProxyDataPort:public Object{
public:
	int Continue(MyServer* server);
	void Dump();
	void OnInput(wxString data);
	void OnClose();

	wxSocketBase *mpSocket;
	ProxyDataPort();
	~ProxyDataPort();
	ProxyType mType;
	ProxyState mState;
	ProxyDataPort *mProxy;
	ObjHttpRequest *mRequest;

private:
	void DoConnection(wxIPV4address &addr, wxEvtHandler* evtHandler);
	wxString mData;
};
class MyServer:public wxEvtHandler{
private:
	static bool mInstanceFlag;
	static MyServer *mSingle;
	MyServer();
	~MyServer();
public:
    static MyServer* GetInstance();
	void (*mOnNewRequest)(wxString);
	void (*mOnCloseRequest)();
	list<ProxyDataPort*> mProxyList;
	bool mIntercept;
	bool mExcludeNonhtml;
public: 
	wxSocketServer* CreateMyServerSocket(int nPort);
	void OnServerEvent(class wxSocketEvent& evt);
	void SendNextRequest();
	void DeleteOldObjects();
	void SetOptions(bool intercept, bool excludeNonhtml);
	ObjHttpRequest* GetCurrentRequest();
	void Dump();
	void OnSocketEvent(class wxSocketEvent& evt);
	void MySetupSocketEvents(wxSocketServer* pServerSocket, wxEvtHandler* pHandler, void (*onNewRequest)(wxString), void (*onCloseRequest)());
	list<pair<wxLongLong, ProxyDataPort*> > ProxysPendigDelete;
	wxDateTime StartingTime;
};
template <class T1, class T2>
struct EqualBySecond
{
	T2 mValue;
	EqualBySecond(pair<T1, T2> &par){
		mValue = par.second;
	}
	bool operator()(pair<T1, T2> &par){
		if(par.second == mValue) return true ;
		return false;
	}
};

#endif
// _MYSERVER_H_
