/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#include "wx/wxprec.h"
#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif
#include "mysock.h"

//#include "pro1.h"
#include <map>


extern MyFrame *mainWindow;
bool ObjHttpRequest::IsHtml(){
	size_t endline_pos = mData.find_first_of(wxString::FromAscii("\r\n"));
	wxString first_line = mData.Mid(0,endline_pos);
	size_t pos;
	pos = first_line.find(wxT("/ "));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT("/\t"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT("/?"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".shtm"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".xhtm"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".htm"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".cfm"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".hdml"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".xhdml"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".ssi"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".fcg"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".htx"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".cgi"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".fcgi"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".php"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".asp"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".pl"));
	if(pos != wxString::npos) return true;
	pos = first_line.find(wxT(".jsp"));
	if(pos != wxString::npos) return true;
	return false;
}
bool ObjHttpRequest::IsHeaderComplete(){
	size_t end_header_pos = mData.find(wxString::FromAscii("\r\n\r\n"));
	if (end_header_pos != wxString::npos) return true;
	end_header_pos = mData.find(wxString::FromAscii("\n\n"));
	if (end_header_pos != wxString::npos) return true;
	return false;
}
ObjHttpRequest::ObjHttpRequest(){
	mData = wxT("");
}
void ObjHttpRequest::StripHeader(wxString header, size_t end_header_pos){
	size_t connection_pos = mData.find(header);
	if(connection_pos < end_header_pos){
		size_t connection_end = mData.find(wxT("\n"),connection_pos);
		wxString data_before = mData.Mid(0,connection_pos);
		wxString data_after = mData.Mid(connection_end+1);
		mData = data_before + data_after;
	}
}
void ObjHttpRequest::ProcessHeaders(){
	size_t end_header_pos = mData.find(wxT("\r\n\r\n"));
	if (end_header_pos == wxString::npos) end_header_pos = mData.find(wxT("\n\n"));
	StripHeader(wxT("Proxy-Connection"), end_header_pos);
	StripHeader(wxT("Accept-Encoding"), end_header_pos);
	StripHeader(wxT("Keep-Alive"), end_header_pos);
//	StripHeader(wxT("Content-Encoding"));
	StripHeader(wxT("Connection"), end_header_pos);
}
wxString ObjHttpRequest::GetUnproxyData(){
	size_t endline_pos = mData.find_first_of(wxString::FromAscii("\r\n"));
	wxString first_line = mData.Mid(0,endline_pos);
	size_t http_pos = first_line.rfind(wxT("HTTP"));
	if(endline_pos == wxString::npos) first_line = wxT("HTTP tag not found");
	else{
		size_t dot_pos = first_line.rfind(wxT("."));
		if(dot_pos == wxString::npos || dot_pos < http_pos) first_line = wxT("Unknow http header");
		else{
			first_line[dot_pos+1] = '0'; //set http version 1.0 
			first_line[dot_pos-1] = '1';

			size_t pos = first_line.find_first_of(wxString::FromAscii(" \t"));
			if(pos != wxString::npos){
				size_t uri_start = first_line.find_first_not_of(wxString::FromAscii(" \t"), pos);
				if(uri_start != wxString::npos){
					pos = first_line.find_first_of(wxString::FromAscii("/"), uri_start);
					size_t host_start = mData.find_first_not_of(wxString::FromAscii("/"), pos);
					if(host_start != wxString::npos) {
						size_t host_end = mData.find_first_of(wxString::FromAscii("/"), host_start);
						wxString s_prehost = first_line.Mid(0,uri_start);
						wxString s_posthost = first_line.Mid(host_end);
						first_line = s_prehost + s_posthost;
					}
				}
			}
		}
	}
	return first_line + mData.Mid(endline_pos);
}
wxString ObjHttpRequest::GetHostname(){
	wxString host = GetHostnameComplete();
	size_t separator = host.find_first_of(wxString::FromAscii(":"));
	if(separator == wxString::npos) return host;
	host = host.Mid(0,separator);
	return host;
}
wxString ObjHttpRequest::GetService(){
	wxString port = GetHostnameComplete();
	size_t separator = port.find_first_of(wxString::FromAscii(":"));
	if(separator == wxString::npos) return wxString::FromAscii("80");
	port = port.Mid(separator+1);
	return port;
}
wxString ObjHttpRequest::GetHostnameComplete(){
	size_t endlinepos = mData.find_first_of(wxString::FromAscii("\r\n"));
	if(endlinepos == wxString::npos) return wxString::FromAscii("");
	size_t pos = mData.find_first_of(wxString::FromAscii(" \t"));
	size_t uri_start = mData.find_first_not_of(wxString::FromAscii(" \t"), pos);
	if(uri_start == wxString::npos) return wxString::FromAscii("");
	size_t uri_end = mData.find_first_of(wxString::FromAscii(" \t"), uri_start);
	wxString uri = mData.Mid(uri_start, uri_end-uri_start);
	pos = mData.find_first_of(wxString::FromAscii("/"));
	size_t host_start = mData.find_first_not_of(wxString::FromAscii("/"), pos);
	if(host_start == wxString::npos) return wxString::FromAscii("");
	size_t host_end = mData.find_first_of(wxString::FromAscii("/"), host_start);
	wxString addr = mData.Mid(host_start, host_end-host_start);
	return addr;
}
void ObjHttpRequest::Dump(){
	wxString s;
	s<<wxT(" mProxyService ")<<mProxyService;
	s<<wxT(" mProxyHostname ")<<mProxyHostname;
	Object::Dump();
}
//ObjHttpRequest::~ObjHttpRequest(){
//	wxString msg;
//	msg.Printf(_("deleting %d"),(int)this);
//	DLOG(msg);
//}
