/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
/////////////////////////////////////////////////////////////////////////////
// Name:        optionsdialog.cpp
// Purpose:     
// Author:      
// Modified by: 
// Created:     07/03/2006 13:42:45
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

//#if defined(__GNUG__) && !defined(__APPLE__)
//#pragma implementation "optionsdialog.h"
//#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

//#ifdef __BORLANDC__
//#pragma hdrstop
//#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "optionsdialog.h"

////@begin XPM images
////@end XPM images

/*!
 * OptionsDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( OptionsDialog, wxDialog )

/*!
 * OptionsDialog event table definition
 */

BEGIN_EVENT_TABLE( OptionsDialog, wxDialog )

////@begin OptionsDialog event table entries
    EVT_BUTTON( CANCELOPTIONBTN, OptionsDialog::OnCanceloptionbtnClick )

    EVT_BUTTON( OKOPTIONBTN, OptionsDialog::OnOkoptionbtnClick )

////@end OptionsDialog event table entries

END_EVENT_TABLE()

/*!
 * OptionsDialog constructors
 */

OptionsDialog::OptionsDialog( )
{
	mParent = NULL;
}

OptionsDialog::OptionsDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
    Create(parent, id, caption, pos, size, style);
	mParent = parent;
}

/*!
 * OptionsDialog creator
 */

bool OptionsDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin OptionsDialog member initialisation
////@end OptionsDialog member initialisation

////@begin OptionsDialog creation
    SetExtraStyle(GetExtraStyle()|wxWS_EX_BLOCK_EVENTS);
    wxDialog::Create( parent, id, caption, pos, size, style );

    CreateControls();
    GetSizer()->Fit(this);
    GetSizer()->SetSizeHints(this);
    Centre();
////@end OptionsDialog creation
    return true;
}

/*!
 * Control creation for OptionsDialog
 */

void OptionsDialog::CreateControls()
{    
////@begin OptionsDialog content construction
    OptionsDialog* itemDialog1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemDialog1->SetSizer(itemBoxSizer2);

    wxBoxSizer* itemBoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer3, 0, wxALIGN_LEFT|wxALL, 5);

    wxCheckBox* itemCheckBox4 = new wxCheckBox( itemDialog1, USEPROXYCHKBOX, _("Use Proxy"), wxDefaultPosition, wxDefaultSize, wxCHK_2STATE );
    itemCheckBox4->SetValue(false);
    itemBoxSizer3->Add(itemCheckBox4, 0, wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5);

    wxStaticBox* itemStaticBoxSizer5Static = new wxStaticBox(itemDialog1, wxID_ANY, _("Proxy Options"));
    wxStaticBoxSizer* itemStaticBoxSizer5 = new wxStaticBoxSizer(itemStaticBoxSizer5Static, wxVERTICAL);
    itemBoxSizer2->Add(itemStaticBoxSizer5, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxFlexGridSizer* itemFlexGridSizer6 = new wxFlexGridSizer(2, 2, 0, 0);
    itemStaticBoxSizer5->Add(itemFlexGridSizer6, 0, wxALIGN_CENTER_HORIZONTAL|wxLEFT|wxRIGHT, 5);

    wxStaticText* itemStaticText7 = new wxStaticText( itemDialog1, wxID_STATIC, _("Host :  http://"), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer6->Add(itemStaticText7, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl8 = new wxTextCtrl( itemDialog1, HOSTOPTIONTXTCTL, _T(""), wxDefaultPosition, wxSize(150, -1), 0 );
    itemFlexGridSizer6->Add(itemTextCtrl8, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxStaticText* itemStaticText9 = new wxStaticText( itemDialog1, wxID_STATIC, _("Port :      "), wxDefaultPosition, wxDefaultSize, 0 );
    itemFlexGridSizer6->Add(itemStaticText9, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxADJUST_MINSIZE, 5);

    wxTextCtrl* itemTextCtrl10 = new wxTextCtrl( itemDialog1, PORTOPTIONTXTCTL, _T(""), wxDefaultPosition, wxSize(50, -1), 0 );
    itemFlexGridSizer6->Add(itemTextCtrl10, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxBoxSizer* itemBoxSizer11 = new wxBoxSizer(wxHORIZONTAL);
    itemBoxSizer2->Add(itemBoxSizer11, 0, wxALIGN_CENTER_HORIZONTAL|wxALL, 5);

    wxButton* itemButton12 = new wxButton( itemDialog1, CANCELOPTIONBTN, _("Cancel"), wxDefaultPosition, wxDefaultSize, 0 );
    itemBoxSizer11->Add(itemButton12, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxButton* itemButton13 = new wxButton( itemDialog1, OKOPTIONBTN, _("Ok"), wxDefaultPosition, wxDefaultSize, 0 );
    itemButton13->SetDefault();
    itemBoxSizer11->Add(itemButton13, 0, wxALIGN_CENTER_VERTICAL|wxALL, 5);

////@end OptionsDialog content construction
}

/*!
 * Should we show tooltips?
 */

bool OptionsDialog::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap OptionsDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin OptionsDialog bitmap retrieval
    wxUnusedVar(name);
    return wxNullBitmap;
////@end OptionsDialog bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon OptionsDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin OptionsDialog icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end OptionsDialog icon retrieval
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for CANCELOPTIONBTN
 */

void OptionsDialog::OnCanceloptionbtnClick( wxCommandEvent& WXUNUSED(event) )
{
	EndModal(wxID_CANCEL);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for OKOPTIONBTN
 */
void OptionsDialog::OnOkoptionbtnClick(wxCommandEvent& WXUNUSED(event))
{
	EndModal(wxID_OK);
}
bool OptionsDialog::GetUseProxy(){
	wxCheckBox* ctl = wxDynamicCast(FindWindow(USEPROXYCHKBOX), wxCheckBox);
	return ctl->IsChecked();
}
void OptionsDialog::SetUseProxy(bool value){
	wxCheckBox* ctl = wxDynamicCast(FindWindow(USEPROXYCHKBOX), wxCheckBox);
	return ctl->SetValue(value);
}
wxString OptionsDialog::GetProxyHost(){
	wxTextCtrl* ctl = wxDynamicCast(FindWindow(HOSTOPTIONTXTCTL), wxTextCtrl);
	return ctl->GetValue();
}
void OptionsDialog::SetProxyHost(wxString value){
	wxTextCtrl* ctl = wxDynamicCast(FindWindow(HOSTOPTIONTXTCTL), wxTextCtrl);
	return ctl->SetValue(value);
}
wxString OptionsDialog::GetProxyPort(){
	wxTextCtrl* ctl = wxDynamicCast(FindWindow(PORTOPTIONTXTCTL), wxTextCtrl);
	return ctl->GetValue();
}
void OptionsDialog::SetProxyPort(wxString value){
	wxTextCtrl* ctl = wxDynamicCast(FindWindow(PORTOPTIONTXTCTL), wxTextCtrl);
	return ctl->SetValue(value);
}
