/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#ifndef _OPTIONSDIALOG_H_
#define _OPTIONSDIALOG_H_

//#if defined(__GNUG__) && !defined(__APPLE__)
//#pragma interface "optionsdialog.cpp"
//#endif

/*!
 * Includes
 */

////@begin includes
////@end includes

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_DIALOG 10058
#define SYMBOL_OPTIONSDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_OPTIONSDIALOG_TITLE _("Options")
#define SYMBOL_OPTIONSDIALOG_IDNAME ID_DIALOG
#define SYMBOL_OPTIONSDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_OPTIONSDIALOG_POSITION wxDefaultPosition
#define USEPROXYCHKBOX 10052
#define HOSTOPTIONTXTCTL 10054
#define PORTOPTIONTXTCTL 10000
#define CANCELOPTIONBTN 10055
#define OKOPTIONBTN 10056
////@end control identifiers

/*!
 * Compatibility
 */

#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif

/*!
 * OptionsDialog class declaration
 */

class OptionsDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( OptionsDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    OptionsDialog( );
    OptionsDialog( wxWindow* parent, wxWindowID id = SYMBOL_OPTIONSDIALOG_IDNAME, const wxString& caption = SYMBOL_OPTIONSDIALOG_TITLE, const wxPoint& pos = SYMBOL_OPTIONSDIALOG_POSITION, const wxSize& size = SYMBOL_OPTIONSDIALOG_SIZE, long style = SYMBOL_OPTIONSDIALOG_STYLE );
    
    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_OPTIONSDIALOG_IDNAME, const wxString& caption = SYMBOL_OPTIONSDIALOG_TITLE, const wxPoint& pos = SYMBOL_OPTIONSDIALOG_POSITION, const wxSize& size = SYMBOL_OPTIONSDIALOG_SIZE, long style = SYMBOL_OPTIONSDIALOG_STYLE );

    /// Creates the controls and sizers
    void CreateControls();

////@begin OptionsDialog event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for CANCELOPTIONBTN
    void OnCanceloptionbtnClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for OKOPTIONBTN
    void OnOkoptionbtnClick( wxCommandEvent& event );

////@end OptionsDialog event handler declarations

////@begin OptionsDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end OptionsDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin OptionsDialog member variables
////@end OptionsDialog member variables
    bool GetUseProxy();
	void SetUseProxy(bool value);

    wxString GetProxyHost();
    void SetProxyHost(wxString value);

    wxString GetProxyPort();
    void SetProxyPort(wxString value);
	wxWindow *mParent;
};

#endif
    // _OPTIONSDIALOG_H_
