/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#include "utils.h"
bool Context::mInstanceFlag = false;
Context* Context::mSingle = NULL;
void Context::CheckPoint(int point){
	map<int, Object*> :: iterator p_iter;
	for ( p_iter = mObjectMap.begin( ) ; p_iter != mObjectMap.end( ) ; p_iter++ )
		p_iter->second->mCheckPoint = point;
}
void Context::Dump(int point){
	map<int, Object*> :: iterator p_iter;
	for ( p_iter = mObjectMap.begin( ) ; p_iter != mObjectMap.end( ) ; p_iter++ )
		p_iter ->second ->mMark = 0;
	for ( p_iter = mObjectMap.begin( ) ; p_iter != mObjectMap.end( ) ; p_iter++ )
		if((p_iter ->second)->mCheckPoint == point) p_iter ->second->Dump();
}
Context::~Context()
{
	mInstanceFlag = false;
}
void Context::DumpAll(){
	map<int, Object*> :: iterator p_iter;
	for ( p_iter = mObjectMap.begin( ) ; p_iter != mObjectMap.end() ; p_iter++)
		p_iter -> second ->mMark = 0;
	for ( p_iter = mObjectMap.begin( ) ; p_iter != mObjectMap.end() ; p_iter++ )
	p_iter -> second ->Dump();
}
Context::Context(){
	mLastId=0;
}
Context* Context::GetInstance()
{
	if(! mInstanceFlag)
	{
		mSingle = new Context();
		mInstanceFlag = true;
		return mSingle;
	}
	else return mSingle;
}
void Object::Dump(wxChar *str){
	wxString wxstr(str);
	Dump(wxstr);
}
void Object::Dump(wxString str){
	if(!mMark){
		wxString s;
		//s<<typeid(*this).name()<<wxT(" Object-id: ")<<mId<<wxT(" mCheckPoint: ")<<mCheckPoint<<wxT(" mMark: ")<<mMark << str;
		//wxLogDebug(s);
		mMark = 1;
	}
}
Object::~Object(){
	map<int, Object*> :: iterator p_iter;
	Context *ctx = Context::GetInstance();
	p_iter = ctx->mObjectMap.find(mId);
	ctx->mObjectMap.erase(p_iter);
}
Object::Object(){
	Context *ctx = Context::GetInstance();
	mId = ctx->mLastId+1;
	ctx->mLastId = mId;
	mMark = 0;
	mCheckPoint = 0;
	ctx->mObjectMap[mId] = this;
}
tracing_output_debug_string::tracing_output_debug_string( const char* file, int line ):m_file( file ),m_line( line )    {  }
void tracing_output_debug_string::operator()( const wxString Format )
{
	#ifndef __GNUC__
	//va_list va;
	//va_start(va, Format);
	//char buf1[MY_BUFFER_SIZE];
	//char buf2[MY_BUFFER_SIZE];
	wxString r=wxT("");
	r<<wxString::FromAscii(m_file)<<wxT(":")<<m_line<<wxT(" ")<<Format;
	//wxLogDebug(r);
	//  add the __FILE__ and __LINE__ to the front:
	/*if(_snprintf(buf1, MY_BUFFER_SIZE-1, "%s:%d %s", m_file, m_line, Format.c_str()) < 0)
		buf1[MY_BUFFER_SIZE-1] = 0;*/
//	if(_vsnprintf(buf2, MY_BUFFER_SIZE-1, buf1, va) < 0)
//		buf2[MY_BUFFER_SIZE-1] = 0;
	//wxLogDebug(wxString::FromAscii(buf1));
	#endif
}
