/*
** Injection Framework - Automatized Sql Injection Tool
** Copyright (C) 2006 Flowgate Security Consulting,
**         http://www.flowgate.net
**
** This program is free software; you can redistribute it and/or modify it
** under the terms of the GNU General Public License as published by the
** Free Software Foundation; either version 2 of the License, or (at your
** option) any later version.
** 
** This program is distributed in the hope that it will be useful, but
** WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** General Public License for more details.
** 
** The GNU General Public License is available from http://www.gnu.org/ or
** the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
** MA 02111-1307, USA.
**
** For information on Injection Framework: fg_injector@flowgate.net

*/
#pragma once
#ifndef _UTILS_H
#define _UTILS_H

#include <map>
#include <stdarg.h>
#include "wx/log.h"
using namespace std;
#include <iostream>

class Object{
public:
	int mId;
	int mCheckPoint;
	int mMark;
	Object();
	~Object();
	virtual void Dump(){Dump(wxT(""));}
	//virtual void Dump()=0;
	virtual void Dump(wxString str);
	virtual void Dump(wxChar *str);
};

class Context
{
public:
    static bool mInstanceFlag;
    static Context *mSingle;
    Context();
public:
    static Context* GetInstance();
    ~Context();
	void CheckPoint(int point = 1);
	void Dump(int point = 0);
	void DumpAll();
	map<int, Object*> mObjectMap;
	int mLastId;
};

class tracing_output_debug_string
{
private:
    const char* m_file;
    int m_line;
    enum { MY_BUFFER_SIZE = 40024 };

public:
    tracing_output_debug_string( const char* file, int line );
    void operator()( const wxString Format );
};
#ifndef __noop
#define __noop {;}
#endif
#ifdef _DEBUG
#	define DLOG (tracing_output_debug_string( __FILE__, __LINE__ ))
#else
#	define DLOG __noop
#endif
#endif //_UTILS_H
